﻿Public Class Form1

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.FillTable1()
        Me.FillTable2()
        Me.FillTable3()

        With Me.TreeViewAdv1
            .DataSource = Me.DataSet1
            .DisplayMember = "Name"

            'Set to table with numberic primary key
            .DataMember = "Elements"
            .ParentMember = "ParentId"
            .ChildMember = "Id"
            .SelfRelationRootValue = "0"

            ''Set to table with Guids
            '.DataMember = "ElementsGuid"
            '.ParentMember = "ParentIdString"
            '.ChildMember = "IdString"
            '.SelfRelationRootValue = Guid.Empty.ToString

            ''Set to table with String Guids
            '.DataMember = "ElementsGuidS"
            '.ParentMember = "ParentId"
            '.ChildMember = "Id"
            '.SelfRelationRootValue = Guid.Empty.ToString
        End With
    End Sub

    Private Sub FillTable1()
        'This works
        Dim topElement = Me.DataSet1.Elements.AddElementsRow(1, "Top", Nothing)
        Dim midElement = Me.DataSet1.Elements.AddElementsRow(2, "Middle", topElement.Id)
        Dim botElement = Me.DataSet1.Elements.AddElementsRow(3, "Leaf", midElement.Id)

        'This fails
        'Setting the primary key to auto increment also fails; the key starts from -1 and numbers down.
        'Dim topElement = Me.DataSet1.Elements.AddElementsRow(-1, "Top", Nothing)
        'Dim midElement = Me.DataSet1.Elements.AddElementsRow(-2, "Middle", topElement.Id)
        'Dim botElement = Me.DataSet1.Elements.AddElementsRow(-3, "Leaf", midElement.Id)
    End Sub

    Private Sub FillTable2()
        'This does not work. The function for selecting children seems to expect String
        Dim topElement = Me.DataSet1.ElementsGuid.AddElementsGuidRow(Guid.NewGuid, "Top", Guid.Empty)
        Dim midElement = Me.DataSet1.ElementsGuid.AddElementsGuidRow(Guid.NewGuid, "Middle", topElement.Id)
        Dim botElement = Me.DataSet1.ElementsGuid.AddElementsGuidRow(Guid.NewGuid, "Leaf", midElement.Id)
    End Sub

    Private Sub FillTable3()
        'This does not work. The function for selecting children seems to expect String
        Dim topElement = Me.DataSet1.ElementsGuidS.addElementsGuidSRow(Guid.NewGuid.ToString, "Top", Guid.Empty.ToString)
        Dim midElement = Me.DataSet1.ElementsGuidS.addElementsGuidSRow(Guid.NewGuid.ToString, "Middle", topElement.Id)
        Dim botElement = Me.DataSet1.ElementsGuidS.AddElementsGuidSRow(Guid.NewGuid.ToString, "Leaf", midElement.id)
    End Sub

End Class
